'
' -------------------------------------------------------------------
' FbToRqInc    FbToRqInc.Bas      June 6th, 2006           by Jacques
' -------------------------------------------------------------------
'
$INCLUDE "Qini_jp.Inc"
$Include "ShellRedir.Inc"
'
$INCLUDE "QREDEX.INC"
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
$Resource FAST_ICO As "Fast.Ico"
'
' CHANGE THE FOLLOWING CONST TO FILL YOUR NEEDS
' =============================================
Const MAX_HEX_PER_LINE = 16
Const FONT_SIZE_RICHEDIT = 12
Const FONT_SIZE_FILEDIRBOX = 8
DefInt flagShowMessages = True   ' comment to avoid all the intermediary messages
Const VERSION = "V0.0.1"
' =============================================
'
$OPTION ICON "Fast.ICO"
'
Declare Function WaitForSingleObject Lib "kernel32" Alias "WaitForSingleObject" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Declare Function FBASM_SendMessageX Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, _
                                                                 ByVal wParam As Long, lParam As Long) As Long
Const EM_EXLINEFROMCHAR = 1078
'
Declare Sub OnClose_frmFBTORQINC
Declare Sub OnClic_AnyMenu (Sender As QMenuItem)
Declare Sub OnClic_btnRefresh
Declare Sub OnChange_Directory
Declare Sub OnChange_edtFileFilter (Key As Long)
Declare Sub OnDblClick_lstFiles
Declare Function FbCompileToAsm () As String
Declare Sub ShellRedirCallBack (Text As String)
Declare Function ExtractNextAsmFunction () As String
Declare Sub Wait (duration As Single)
Declare Function TranslateASMtoNASM (sAsm as string) As String
Declare Function NasmToBin () As String
Declare Sub BintoRQInc
Declare Sub DeletePreviousFiles
Declare Sub OnMouseDown_rchDoc
Declare Sub OnClose_frmViewDoc (Action As Long)
Declare SUB MinSet (fhand as integer, gwl_hand as integer, hwnd as integer, apphand as integer)
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, _
                 ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'
Dim myIni As QIni
$Include "Form.Inc"
$Include "Documentation.Inc"
'
' ---------------------------------------------------------------------
' To Correct RapidQ Minimizing on the DeskTop
' -------------------------------------------
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG, nIndex AS LONG, dwNewLong AS LONG) AS LONG
SUB MinSet (fhand as integer, gwl_hand as integer, hwnd as integer, apphand as integer)
    setwindowlong(fhand, Gwl_Hand, hwnd)
    setwindowlong(apphand, GWL_Hand, fhand)
End SUB
MinSet(frmFBTORQINC.handle, -8, 0, application.handle)
' ---------------------------------------------------------------------
DefStr sNowDir
DefStr sSelPath = "", sSelFile = "", sSelPathFile = "", sSelFileNoExt = "", sSelExt = ""
DefStr sAppDir = Command$(0) - Application.ExeName
sNowDir = myIni.Read ("InitialDir", sAppDir)
edtDirectory.Text = sNowDir
dirTree.InitialDir = sNowDir
ChDir sNowDir
lstFiles.Directory = sNowDir
DefInt flagMenuBusy = False
DefStr sError = "", sFuncName, sAllInc, sAll
DefInt iScanAsmLine = 0, iArgNumber
'
' *************************************
frmFBTORQINC.Show
' *************************************
'
DefInt iRet
If FileExists (sAppDir & "Fbc.exe") = 0 Then   
    If MessageDlg(" FBC.EXE, THE FREEBASIC WIN32 COMPILER,\n IS NOT IN THE  \"FbToRqIn\"  DIRECTORY" _
                & "\n\n IF YOU HAVE A RECENT VERSION (>014) OF IT,\n COPY IT IN  \"FbToRqIn\"  DIRECTORY NOW !" _
                & "\n\n ??? IF NOT, DO YOU WANT TO DOWNLOAD IT\n AT FreeBasic SITE NOW ??? ", mtConfirmation, mbYes OR mbNo, 0) = IdYes Then
        iRet = ShellExecute (frmFBTORQINC.Handle, "Open", "http://prdownloads.sourceforge.net/fbc/FB-v0.16b-may-29-testing-win32.zip?download", "", "", 1) ' 27
    End If
End If
'
If FileExists (sAppDir & "Nasmw.exe") = 0 Then   
    If MessageDlg(" NASMW.EXE, THE NASMW WIN32 COMPILER,\n IS NOT IN THE  \"FbToRqIn\"  DIRECTORY" _
                & "\n\n IF YOU HAVE A VERSION OF IT,\n COPY IT IN  \"FbToRqIn\"  DIRECTORY NOW !" _
                & "\n\n ???  DO YOU WANT TO DOWNLOAD IT\n AT NASM SOURCEFORGE SITE NOW ??? ", mtConfirmation, mbYes OR mbNo, 0) = IdYes Then
        iRet = ShellExecute (frmFBTORQINC.Handle, "Open", "http://prdownloads.sourceforge.net/nasm/nasm-0.98.40-win32.zip?download", "", "", 1)  ' 39
    End If
End If
'
If (FileExists (sAppDir & "Nasmw.exe") = 0 Or FileExists (sAppDir & "Fbc.exe") = 0) Then   
    ShowMessage ("FbToRqInc  CANNOT WORK WITHOUT FBC.EXE  and  NASMW.EXE\n\n" _
              &   "IN THE DIRECTORY OF  \"FbToRqInc\"\n\n   ***  I WILL QUIT  ***    Nothing Done")
    Application.Terminate
End If
'
DefStr sTmp = "---- WELCOME TO FBTORQINC Version  " & VERSION & "  ----"
rchWin.AddString = "  " & sTmp & "\n  " & String$(Len(sTmp), "-") _
               & "\n\n  - HELP_KEYWORD  :  SELECT A FREEBASIC KEYWORD IN THE EDIT WINDOW" _
                 & "\n         AND THE HELP ABOUT THIS FREEBASIC KEYWORD WILL BE DISPLAYED" _
               & "\n\n  - HELP/FB_WIKIPEDIA : WILL RUN YOUR DEFAULT BROWSER TO FREEBASIC " _
                 & "\n         WIKIPEDIA PAGE" _
               & "\n\n  - HELP/FB_FORUMS    : WILL RUN YOUR DEFAULT BROWSER TO FREEBASIC FORUMS'PAGE" _
               & "\n\n  ------------"
rchWin.AddString ("\n\n\n   !!!!  FREEBASIC ARGUMENTS ARE BY DEFAULT PASSED BYREF, SO DONT  !!!!" _
                  & "\n\n                !!!!  FORGET TO ADD THE HEADER  \"BYVAL\"  !!!!")
rchWin.AddString     ("\n  ------------\n\n   Enjoy")
'
' *************************************
frmFBTORQINC.Visible = False
frmFBTORQINC.ShowModal
' *************************************
'
$Include "Menu.Inc"
$Include "Events.Inc"
$Include "Functions.Inc"
'
