'
' -------------------------------------------------------------------
' FbToRqInc       Form.Inc       June 6th, 2006            by Jacques
' -------------------------------------------------------------------
'
Create frmFBTORQINC As QForm
    Center
    Width = Val(myIni.Read ("FormWidth", "900")) ' 900
    height = Val(myIni.Read ("FormHeight", "800")) ' 800
    Caption = "frmFBtoRQINC   " & VERSION
    AutoScroll = False
    OnClose = OnClose_frmFBTORQINC
'    Font.Name = "Courier"
    Font.Size = FONT_SIZE_FILEDIRBOX 'FONT_SIZE_RICHEDIT
    Create pnlRight As QPanel
        Width = Val(myIni.Read("pnlRightWidth", Str$(frmFBTORQINC.ClientWidth * 0.25)))
        Align = alRight
        Create dirTree AS QDirTree
            Height =  Val(myIni.Read("dirTreeHeight", Str$(frmFBTORQINC.ClientHeight/2)))
            Align = alTop
            InitialDir = CURDIR$
            OnChange = OnChange_Directory
        End Create
        Create pnlRightTop As QPanel
            Height = 75
            Align = alTop
            Create btnRefresh AS QButton
                Height = 25
                Align = alTop
                Font.Bold = True
                Font.Size = 12
                Caption = "&REFRESH"
                OnClick = OnClic_btnRefresh
            End Create
            Create pnlRightTop_up As QPanel
                Height = 25
                Align = alTop
                Create lblMyLabel As QLabel
                    Height = 25
                    align = alLeft
                    Font.Size = 12
                    Caption = " Files Filter : "
                End Create
                Create edtFileFilter AS QEdit
                    align = alClient
                    Width = 60
                    Height = 25
                    Font.Size = 8
                    Font.Bold = True
                    Text =  myIni.Read ("FileFilter", "*.Asm;*.Bas;*.Nasm;*.Inc") ' "*.*"
                    OnChange = OnChange_edtFileFilter
                    ShowHint = True
                    Hint = "Filter For Files, WildCards Allowed (*, ?)"
                End Create
            End Create
            Create edtDirectory AS QEdit
                Height = 25
                align = alClient
                Font.Bold = True
            End Create
        End Create
        Create Splitter_H AS QSPLITTER
            Align = alTop
            Cursor = crVSplit
            MinSize = 100
            Height = 8
            Color = &H00FF00
        End Create
        Create lstFiles AS QFileListBox
            Height = 300
            Align = alClient
            Mask = "*.*"
            OnDblClick = OnDblClick_lstFiles
        End Create
    End Create
    Create Splitter_V AS QSPLITTER
        Width = 8
        Align = alRight
        Cursor = crHSplit
        MinSize = 100
        Color = &HFF0000
    End Create
    Create pnlLeft As QPanel
        Align = alClient
        Create rchWin AS QRichEdit
            Align = alClient
            Font.Name = "courier"
            Font.Size =  FONT_SIZE_RICHEDIT
            Font.Color = &H800000
'            ReadOnly = True
            WordWrap = False
            ScrollBars = ssBoth
            HideSelection = False
            PlainText = True
            ExtendSizeLimit
        End Create
        Create rchDoc AS QRichEdit
            Align = alClient
            Font.Name = "courier"
            Font.Size =  FONT_SIZE_RICHEDIT
            Font.Color = &H800000
            ReadOnly = True
            WordWrap = False
            ScrollBars = ssBoth
            PlainText = True
            ExtendSizeLimit
            Visible = False
            OnMouseDown = OnMouseDown_rchDoc
            Color = &HE6F9F0
        End Create
    End Create
    Create mnuMain AS QMAINMENU
        Create mnuFile AS QMENUITEM
            Caption = "&FILE    "
            Create mnuSep_01 AS QMENUITEM
                Caption = "  ---"
            End Create
            Create mnuNew AS QMENUITEM
                Caption = "&NEW"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSaveAs AS QMENUITEM
                Caption = "&SAVE  AS"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuNewDir AS QMENUITEM
                Caption = "&CREATE/KILL  DIR"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSep_05 AS QMENUITEM
                Caption = "  ---"
            End Create
        End Create
        Create mnuCompile AS QMENUITEM
            Caption = "&COMPILE    "
            Create mnuSep_1 AS QMENUITEM
                Caption = "  ---"
            End Create
            Create mnuFBBAStoRQINC AS QMENUITEM
                Caption = " FB to RQ INC  :  displayed  freebasic  .bas  code  to  rapidq  &include"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSep_2 AS QMENUITEM
                Caption = "  ---"
            End Create
            Create mnuSelAsm AS QMENUITEM
                Caption = " SEL ASM to RQ INC  :  one  &selected  function  in  a  displayed  freebasic  .asm  code  to  rapidq  include"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSep_3 AS QMENUITEM
                Caption = "  ---"
            End Create
            Create mnuFBBAStoFBASM AS QMENUITEM
                Caption = " FB to FBASM  :  displayed  freebasic  .bas  code  to  freebasic .&asm (to use previous after)"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSep_4 AS QMENUITEM
                Caption = "  ---"
            End Create
        End Create
        Create mnuHelp AS QMENUITEM
            Caption = "&HELP   "
            Create mnuSep_20 AS QMENUITEM
                Caption = "  ---"
            End Create
            Create mnuHelpCompSel AS QMENUITEM
                Caption = "&HELP  COMPILE  \"SEL ASM to RQ INC\"  :  ONE SELECTED  FUNCTION  IN  A  DISPLAYED  FREEBASIC  .ASM  CODE  TO  RAPIDQ  INCLUDE"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSep_21 AS QMENUITEM
                Caption = "  ---"
            End Create
            Create mnuHelpCompFBBAS AS QMENUITEM
                Caption = "&HELP  COMPILE  \"FB to RQ INC\"  :  DISPLAYED  FREEBASIC  .BAS  CODE  TO  RAPIDQ  &INCLUDE"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSep_22 AS QMENUITEM
                Caption = "  ---"
            End Create
            Create mnuHelpHelp AS QMENUITEM
                Caption = "&HELP on VARIOUS HELP"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSep_23 AS QMENUITEM
                Caption = "  ---"
            End Create
            Create mnuWiki AS QMENUITEM
                Caption = "FB_&WIKIPEDIA"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuForum AS QMENUITEM
                Caption = "FB_F&ORUMS"
                OnClick = OnClic_AnyMenu
            End Create
            Create mnuSep_25 AS QMENUITEM
                Caption = "  ---"
            End Create
        End Create
        Create mnuHelpSelected AS QMENUITEM  ' Cant have it work ???
            Caption = "HELP_&KEYWORD"
            OnClick = OnClic_AnyMenu
        End Create
    End Create
End Create
'
Create frmViewDoc As QForm
    Caption = "VIEW FREEBASIC HTML DOC"
    Top = Val(myIni.Read ("FormViewDocTop", "50"))
    Left = Val(myIni.Read ("FormViewDocLeft", "50"))
    Width = Val(myIni.Read ("FormViewDocWidth", Str$(Screen.Width - 300)))
    height = Val(myIni.Read ("FormViewDocHeight", Str$(Screen.Height - 300)))
    parent = frmFBTORQINC
    IcoHandle = FAST_ICO
    Create oleIE AS QOLECONTAINER
        Align = alClient
    End Create   
    Visible = False
    OnClose = OnClose_frmViewDoc
End Create
'
